#include <stdio.h>
#include <sys/shm.h>
#include <sys/msg.h>
#include <sys/stat.h>
#include <errno.h>
#include <sys/ipc.h>
#include <sys/types.h>
#include <unistd.h>
#include <pthread.h>
#include <stdlib.h>
#include <string.h>

#define BUFF_SIZE 1024

typedef struct{
	long mtype;
	char mtext[BUFF_SIZE];
} mymsg_t;
char mynumber;

void *thread(void *message);

int main(int argc, char *argv[])
{
	void *shared_memory = (void *)0;
	char *message;
	int shmid,error;
	char buf[BUFF_SIZE];
	mymsg_t mymsg;
	key_t msg_key;
	pthread_t tid;

	if(argc != 2)
	{
		fprintf(stderr, "번호를 입력해주세요 ex)./sub 2\n");
		return 1;
	}
	mynumber = *argv[1];
	if(-1 == (shmid = shmget((key_t)2321, sizeof(char)*BUFF_SIZE, 0)))
	{
		perror("shmget failed");
		exit(0);
	}

	if((shared_memory = shmat(shmid, (void *)0, IPC_CREAT|0666)) == (void *)-1)
	{
		perror("shamat failed");
		exit(0);
	}

	message = (char *)shared_memory;

	if((msg_key = msgget((key_t)2234, IPC_CREAT|0666)) == -1)
	{
		perror("msgget error:");
		exit(0);
	}

	memset(mymsg.mtext, 0, BUFF_SIZE);
	mymsg.mtype = 1;

	if(error = pthread_create(&tid, NULL, (void*)thread, message))
	{    
		fprintf(stderr, "Failed to create thread: %s\n", strerror(error));
		exit(1);
	}

	while(1)
	{                       
		fgets(buf, BUFF_SIZE, stdin);
		*mymsg.mtext = mynumber;
		memcpy(mymsg.mtext+1, buf, BUFF_SIZE); // argv[1] 저장
		if(-1 == (msgsnd(msg_key, (void *)&mymsg, sizeof(mymsg_t), IPC_NOWAIT) == -1))
		{  
			perror("msgsnd error:");
			exit(0);
		}
	}
	return 0;
}

void *thread(void *message)
{       
	char *flag,*msg,number;
	char buf[BUFF_SIZE];
	int temp,name;
	memset(buf, 0, BUFF_SIZE);
	while(1)
	{
		flag = message;
		number = *(flag+1);
		temp = strcmp(buf, message);
		if( temp && (number != mynumber))
		{
			msg = message + 2;
			name = atoi(&number);
			printf("사용자 %d : %s\n",name,msg);
			memcpy(buf, message, BUFF_SIZE);
		}
	}
}
